Index: typo3/sysext/install/mod/class.tx_install.php
===================================================================
--- typo3/sysext/install/mod/class.tx_install.php	(revision 7289)
+++ typo3/sysext/install/mod/class.tx_install.php	(working copy)
@@ -5211,8 +8327,7 @@
 	}
 }
 
-if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/install/mod/class.tx_install.php'])	{
+if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/install/mod/class.tx_install.php']) {
 	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/install/mod/class.tx_install.php']);
 }
-
-?>
+?>
\ No newline at end of file
Index: typo3/sysext/install/mod/class.tx_install_session.php
===================================================================
--- typo3/sysext/install/mod/class.tx_install_session.php	(revision 7289)
+++ typo3/sysext/install/mod/class.tx_install_session.php	(working copy)
@@ -75,6 +75,13 @@
 	private $regenerateSessionIdTime = 5;
 
 	/**
+	 * part of the referer when the install tool has been called from the backend
+	 *
+	 * @var string
+	 */
+	private $backendFile = 'backend.php';
+
+	/**
 	 * Constructor. Starts PHP session handling in our own private store
 	 *
 	 * Side-effect: might set a cookie, so must be called before any other output.
@@ -136,6 +143,14 @@
 	 */
 	public function startSession() {
 		$_SESSION['created'] = time();
+
+		$referer = parse_url(t3lib_div::getIndpEnv('HTTP_REFERER'));
+		if (strpos($referer['path'], $this->backendFile)) {
+			$_SESSION['backend'] = TRUE;
+		} else {
+			$_SESSION['backend'] = FALSE;
+		}
+
 		return session_id();
 	}
 
@@ -240,6 +255,18 @@
 	}
 
 	/**
+	 * Check if the install tool is called in the backend
+	 *
+	 * @return boolean True if the install tool has been called from the backend
+	 */
+	public function inBackend() {
+		if ($_SESSION['backend']) {
+			return TRUE;
+		}
+		return FALSE;
+	}
+
+	/**
 	 * Refreshes our session information, rising the expire time.
 	 * Also generates a new session ID every 5 minutes to minimize the risk of
 	 * session hijacking.
Index: typo3/sysext/install/Resources/Public/Javascript/install.js
===================================================================
--- typo3/sysext/install/Resources/Public/Javascript/install.js	(revision 0)
+++ typo3/sysext/install/Resources/Public/Javascript/install.js	(revision 0)
@@ -0,0 +1,49 @@
+/***************************************************************
+*
+*  Javascript functions to provide AJAX calls for install tool
+*
+*  Copyright notice
+*
+*  (c) 2009 Marcus Krause, Helmut Hummel <security@typo3.org>
+*  All rights reserved
+*
+*  This script is part of the TYPO3 backend provided by
+*  Kasper Skaarhoj <kasper@typo3.com> together with TYPO3
+*
+*  Released under GNU/GPL (see license file in /typo3/)
+*
+*  This script is distributed in the hope that it will be useful,
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+*
+*  This copyright notice MUST APPEAR in all copies of this script
+*
+***************************************************************/
+
+
+/**
+ *
+ * @author	Marcus Krause
+ */
+var EncryptionKey = {
+	thisScript: '../../index.php',
+	eID: 'tx_install_ajax',
+	cmd: 'encryptionKey',
+
+		// loads the ecryption key by an AJAX call
+	load: function(obj) {
+			// fallback if AJAX is not possible (e.g. IE < 6)
+		if (typeof Ajax.getTransport() != 'object') {
+			window.location.href = this.thisScript + '?eID=' + this.eID + '&cmd=' + this.cmd;
+			return;
+		}
+
+		new Ajax.Request(this.thisScript, {
+			method: 'get',
+			parameters: '?eID=' + this.eID + '&cmd=' + this.cmd,
+			onComplete: function(xhr) {
+				document.getElementsByName('TYPO3_INSTALL[localconf.php][encryptionKey]').item(0).value=xhr.responseText;
+			}.bind(this)
+		});
+	}
+};
Index: typo3/sysext/install/updates/class.tx_coreupdates_compatversion.php
===================================================================
--- typo3/sysext/install/updates/class.tx_coreupdates_compatversion.php	(revision 7289)
+++ typo3/sysext/install/updates/class.tx_coreupdates_compatversion.php	(working copy)
@@ -52,21 +52,63 @@
 		global $TYPO3_CONF_VARS;
 
 		if ($this->compatVersionIsCurrent())	{
-			$description = '<strong>Up to date!</strong><br />If you do not use the wizard, your current TYPO3 installation is configured to use all the features included in the current release '.TYPO3_version.'.<br />
-			There are two possibilities that you see this screen:<ol><li><b>You just updated from a previous version of TYPO3:</b>
-			Because of some new features, the frontend output of your site might have changed. To emulate the "old" frontend behavior, change the compatibility version by continuing to step 2.
-			This is <b>recommended</b> after every update to make sure the frontend output is not altered. When re-running the wizard, you will see the changes needed for using the new features.
-			<i>Please continue to step two.</i></li>
-			<li><b>You just made a fresh install of TYPO3:</b>
-			Perfect! All new features will be used.
-			<i>You can stop here and do not need this wizard now.</i></li></ol>';
+			$description = '
+				<p>
+					<strong>Up to date!</strong>
+					<br />
+					If you do not use the wizard, your current TYPO3
+					installation is configured to use all the features included
+					in the current release ' . TYPO3_version . '.
+					<br />
+					There are two possibilities that you see this screen:
+				</p>
+				<ol>
+					<li>
+						<strong>You just updated from a previous version of
+						TYPO3:</strong>
+						Because of some new features, the frontend output of
+						your site might have changed. To emulate the "old"
+						frontend behavior, change the compatibility version
+						by continuing to step 2.
+						This is <strong>recommended</strong> after every update
+						to make sure the frontend output is not altered. When
+						re-running the wizard, you will see the changes needed
+						for using the new features.
+						<em>Please continue to step two.</em>
+					</li>
+					<li>
+						<strong>You just made a fresh install of TYPO3:</strong>
+						Perfect! All new features will be used.
+						<em>You can stop here and do not need this wizard now.</em>
+					</li>
+				</ol>
+			';
 
 			if (!$TYPO3_CONF_VARS['SYS']['compat_version'])	{
 				$description .= '
-				The compatibility version has been set to the current TYPO3 version. This is a stamp and has no impact for your installation.';
+					<p>
+						The compatibility version has been set to the current
+						TYPO3 version. This is a stamp and has no impact for
+						your installation.
+					</p>
+				';
 			}
 		} else {
-			$description = 'Your current TYPO3 installation is configured to <b>behave like version '.$TYPO3_CONF_VARS['SYS']['compat_version'].'</b> of TYPO3. If you just upgraded from this version, you most likely want to <b>use new features</b> as well.</p><p>In the next step, you will see the things that need to be adjusted to make your installation compatible with the new features.';
+			$description = '
+				<p>
+					Your current TYPO3 installation is configured to
+					<strong>behave like version
+					' . $TYPO3_CONF_VARS['SYS']['compat_version'] . '
+					</strong> of TYPO3. If you just upgraded from this version,
+					you most likely want to <strong>use new features</strong> as
+					well.
+				</p>
+				<p>
+					In the next step, you will see the things that need to be
+					adjusted to make your installation compatible with the new
+					features.
+				</p>
+			';
 		}
 
 		return 1;	// Return 1 in any case so user has possibility to switch back to a previous compat_version.
@@ -81,24 +123,64 @@
 	function getUserInput($inputPrefix)	{
 		global $TYPO3_CONF_VARS;
 		if ($this->compatVersionIsCurrent())	{
-			$content = '<strong>You updated from an older version of TYPO3</strong>:<br />
-			<label for="'.$inputPrefix.'[version]">Select the version where you have upgraded from:</label> <select name="'.$inputPrefix.'[version]" id="'.$inputPrefix.'[version]">';
+			$content = '
+				<fieldset>
+					<ol>
+						<li>
+							<strong>You updated from an older version of TYPO3</strong>:
+						</li>
+						<li>
+							<label for="version">Select the version where you have upgraded from:</label>
+							<select name="' . $inputPrefix . '[version]" id="version">
+			';
 			$versions = array(
 				'3.8' => '<= 3.8',
 				'4.1' => '<= 4.1',
 				'4.2' => '<= 4.2',
 			);
 			foreach ($versions as $singleVersion => $caption)	{
-				$content .= '<option value="'.$singleVersion.'">'.$caption.'</option>';
+				$content .= '
+								<option value="'.$singleVersion.'">'.$caption.'</option>
+				';
 			}
-			$content .= '</select>';
+			$content .= '
+							</select>
+						</li>
+					</ol>
+				</fieldset>
+			';
 		} else {
-			$content = 'TYPO3 output is currently compatible to version '.$TYPO3_CONF_VARS['SYS']['compat_version'].'. To use all the new features in the current TYPO3 version, make sure you follow the guidelines below to upgrade without problems.<br />
-			<p><strong>Follow the steps below carefully and confirm every step!</strong><br />You will see this list again after you performed the update.</p>';
+			$content = '
+				<p>
+					TYPO3 output is currently compatible to version ' . $TYPO3_CONF_VARS['SYS']['compat_version'] . '.
+					To use all the new features in the current TYPO3 version,
+					make sure you follow the guidelines below to upgrade without
+					problems.
+				</p>
+				<p>
+					<strong>
+						Follow the steps below carefully and confirm every step!
+					</strong>
+					<br />
+					You will see this list again after you performed the update.
+				</p>
+			';
 
 			$content .= $this->showChangesNeeded($inputPrefix);
 
-			$content.= '<p><input type="checkbox" name="'.$inputPrefix.'[compatVersion][all]" id="'.$inputPrefix.'[compatVersion][all]" value="1">&nbsp;<strong><label for="'.$inputPrefix.'[compatVersion][all]">Check all (ignore selection above)<br />WARNING: this might break the output of your website.</label></strong></p><hr />';
+			$content.= '
+				<fieldset>
+					<ol>
+						<li class="labelAfter">
+							<input type="checkbox" name="' . $inputPrefix . '[compatVersion][all]" id="compatVersionAll" value="1" />
+							<label for="compatVersionAll">Check all (ignore selection above)</label>
+						</li>
+						<li>
+							WARNING: this might break the output of your website.
+						</li>
+					</ol>
+				</fieldset>
+			';
 		}
 		return $content;
 	}
@@ -203,15 +285,24 @@
 					$updateWizardBoxes.= '
 						<div style="border: 1px solid; padding: 10px; margin: 10px; padding-top: 0px; width: 500px;">
 							<h3>'.(isset($details['title'])?$details['title']:$internalName).'</h3>
-							<p>'.$description.'</p>'.
+							' . $description .
 							(strlen($description_acknowledge) ? '<p>'.$description_acknowledge.'</p>' : '').
-							(strlen($inputPrefix) ? '<p><input type="checkbox" name="'.$inputPrefix.'[compatVersion]['.$internalName.']" id="'.$inputPrefix.'[compatVersion]['.$internalName.']" value="1">&nbsp;<strong><label for="'.$inputPrefix.'[compatVersion]['.$internalName.']">Acknowledged</label></strong></p>' : '').'
+							(strlen($inputPrefix) ? '
+								<fieldset>
+									<ol>
+										<li class="labelAfter">
+											<input type="checkbox" name="' . $inputPrefix . '[compatVersion][' . $internalName . ']" id="compatVersion' . $internalName . '" value="1" />
+											<label for="compatVersion' . $internalName . '">Acknowledged</label>
+										</li>
+									</ol>
+								</fieldset>
+							' : '').'
 						</div>';
 				}
 			}
 		}
 		if (strlen($updateWizardBoxes))	{
-			return '<table><tr><td>'.$updateWizardBoxes.'</td></tr></table>';
+			return $updateWizardBoxes;
 		}
 		return '';
 	}
Index: typo3/sysext/install/updates/class.tx_coreupdates_installnewsysexts.php
===================================================================
--- typo3/sysext/install/updates/class.tx_coreupdates_installnewsysexts.php	(revision 7289)
+++ typo3/sysext/install/updates/class.tx_coreupdates_installnewsysexts.php	(working copy)
@@ -55,21 +55,40 @@
 	 */
 	public function checkForUpdate(&$description) {
 		$result = false;
-		$description = 'Install the following system extensions that are new in TYPO3 4.3:<br />';
+		$description = '
+			<p>
+				Install the following system extensions that are new in TYPO3
+				4.3:
+			</p>
+		';
 
+		$description .= '
+			<ul>
+		';
+
 		foreach($this->newSystemExtensions as $_EXTKEY) {
 			if (!t3lib_extMgm::isLoaded($_EXTKEY)) {
 				$EM_CONF = FALSE;
 					// extension may not been loaded at this point, so we can't use an API function from t3lib_extmgm
 				require (PATH_site . 'typo3/sysext/' . $_EXTKEY . '/ext_emconf.php');
 				$description .= '
-					<strong>' . $EM_CONF[$_EXTKEY]['title'] . ' [' . $_EXTKEY . ']</strong>
-					' . $EM_CONF[$_EXTKEY]['description'] . '<br />';
+					<li>
+						<strong>
+							' . $EM_CONF[$_EXTKEY]['title'] . ' [' . $_EXTKEY . ']
+						</strong>
+						<br />
+						' . $EM_CONF[$_EXTKEY]['description'] . '
+					</li>
+				';
 
 				$result = true;
 			}
 		}
 
+		$description .= '
+			</ul>
+		';
+
 		return $result;
 	}
 
@@ -80,17 +99,39 @@
 	 * @return	string		HTML output
 	 */
 	public function getUserInput($inputPrefix) {
-		$content = '<strong>Install the following system extensions that are new in TYPO3 4.3:</strong><br />';
+		$content = '
+			<p>
+				<strong>
+					Install the following system extensions that are new in
+					TYPO3 4.3:
+				</strong>
+			</p>
+		';
+
+		$content .= '
+			<fieldset>
+				<ol>
+		';
+
 		foreach($this->newSystemExtensions as $_EXTKEY) {
 			if (!t3lib_extMgm::isLoaded($_EXTKEY)) {
 				$EM_CONF = FALSE;
 					// extension may not been loaded at this point, so we can't use an API function from t3lib_extmgm
 				require (PATH_site . 'typo3/sysext/' . $_EXTKEY . '/ext_emconf.php');
 				$content .= '
-					<input type="checkbox" id="' . $_EXTKEY . '" name="' . $inputPrefix . '[sysext][' . $_EXTKEY . ']" value="1" checked="checked" /><label for="' . $_EXTKEY . '">' . $EM_CONF[$_EXTKEY]['title'] . ' [' . $_EXTKEY . ']</label><br />';
+					<li class="labelAfter">
+						<input type="checkbox" id="' . $_EXTKEY . '" name="' . $inputPrefix . '[sysext][' . $_EXTKEY . ']" value="1" checked="checked" />
+						<label for="' . $_EXTKEY . '">' . $EM_CONF[$_EXTKEY]['title'] . ' [' . $_EXTKEY . ']</label>
+					</li>
+				';
 			}
 		}
 
+		$content .= '
+				</ol>
+			</fieldset>
+		';
+
 		return $content;
 	}
 
Index: typo3/sysext/install/updates/class.tx_coreupdates_installsysexts.php
===================================================================
--- typo3/sysext/install/updates/class.tx_coreupdates_installsysexts.php	(revision 7289)
+++ typo3/sysext/install/updates/class.tx_coreupdates_installsysexts.php	(working copy)
@@ -55,12 +55,44 @@
 	 */
 	public function checkForUpdate(&$description) {
 		$result = false;
-		$description = 'Install the following system extensions as their functionality is moved out of the TYPO3 base installation and now optional:<br />
-		<strong>Help&gt;About [about]</strong><br />Shows info about TYPO3 and installed extensions.<br />
-		<strong>Help&gt;TYPO3 Manual [cshmanual]</strong><br />Shows TYPO3 inline user manual.<br />
-		<strong>Frontend Editing [feedit]</strong><br />This module enables FE-editing, configuration is done by Typoscript.<br />
-		<strong>User&gt;Open Documents [opendocs]</strong><br />Handles the list of opened documents in TYPO3 backend.<br />
-		<strong>Simulate Static URLs [simulatestatic]</strong><br />If you do not want to use RealURL or CoolURI but still want the Speaking URL feature. If you used "config.simulateStaticDocuments = 1" in this installation before, you should install this system extension. Be sure to read the manual of "simulatestatic".';
+		$description = '
+			<p>
+				Install the following system extensions as their functionality
+				is moved out of the TYPO3 base installation and now optional:
+			</p>
+			<ul>
+				<li>
+					<strong>Help&gt;About [about]</strong>
+					<br />
+					Shows info about TYPO3 and installed extensions.
+				</li>
+				<li>
+					<strong>Help&gt;TYPO3 Manual [cshmanual]</strong>
+					<br />
+					Shows TYPO3 inline user manual.
+				</li>
+				<li>
+					<strong>Frontend Editing [feedit]</strong>
+					<br />
+					This module enables FE-editing, configuration is done by
+					Typoscript.
+				</li>
+				<li>
+					<strong>User&gt;Open Documents [opendocs]</strong>
+					<br />
+					Handles the list of opened documents in TYPO3 backend.
+				</li>
+				<li>
+					<strong>Simulate Static URLs [simulatestatic]</strong>
+					<br />
+					If you do not want to use RealURL or CoolURI but still want
+					the Speaking URL feature. If you used
+					"config.simulateStaticDocuments = 1" in this installation
+					before, you should install this system extension. Be sure to
+					read the manual of "simulatestatic".
+				</li>
+			</ul>
+		';
 
 		foreach($this->newSystemExtensions as $ext) {
 			if (!t3lib_extMgm::isLoaded($ext)) {
@@ -77,12 +109,37 @@
 	 * @return	string		HTML output
 	 */
 	public function getUserInput($inputPrefix) {
-		$content = '<strong>Install the following SystemExtensions</strong>:<br />
-		<input type="checkbox" id="about" name="' . $inputPrefix . '[sysext][about]" value="1" checked="checked" /><label for="about">Help&gt;About [about]</label><br />
-		<input type="checkbox" id="cshmanual" name="' . $inputPrefix . '[sysext][cshmanual]" value="1" checked="checked" /><label for="cshmanual">Help&gt;TYPO3 Manual [cshmanual]</label><br />
-		<input type="checkbox" id="feedit" name="' . $inputPrefix . '[sysext][feedit]" value="1" checked="checked" /><label for="feedit">Frontend Editing [feedit]</label><br />
-		<input type="checkbox" id="opendocs" name="' . $inputPrefix . '[sysext][opendocs]" value="1" checked="checked" /><label for="opendocs">User&gt;Open Documents [opendocs]</label><br />
-		<input type="checkbox" id="simulatestatic" name="' . $inputPrefix . '[sysext][simulatestatic]" value="1" checked="checked" /><label for="simulatestatic">Simulate Static URLs [simulatestatic]</label><br />';
+		$content = '
+			<p>
+				<strong>
+					Install the following SystemExtensions
+				</strong>:
+			</p>
+			<fieldset>
+				<ol>
+					<li class="labelAfter">
+						<input type="checkbox" id="about" name="' . $inputPrefix . '[sysext][about]" value="1" checked="checked" />
+						<label for="about">Help&gt;About [about]</label>
+					</li>
+					<li class="labelAfter">
+						<input type="checkbox" id="cshmanual" name="' . $inputPrefix . '[sysext][cshmanual]" value="1" checked="checked" />
+						<label for="cshmanual">Help&gt;TYPO3 Manual [cshmanual]</label>
+					</li>
+					<li class="labelAfter">
+						<input type="checkbox" id="feedit" name="' . $inputPrefix . '[sysext][feedit]" value="1" checked="checked" />
+						<label for="feedit">Frontend Editing [feedit]</label>
+					</li>
+					<li class="labelAfter">
+						<input type="checkbox" id="opendocs" name="' . $inputPrefix . '[sysext][opendocs]" value="1" checked="checked" />
+						<label for="opendocs">User&gt;Open Documents [opendocs]</label>
+					</li>
+					<li class="labelAfter">
+						<input type="checkbox" id="simulatestatic" name="' . $inputPrefix . '[sysext][simulatestatic]" value="1" checked="checked" />
+						<label for="simulatestatic">Simulate Static URLs [simulatestatic]</label>
+					</li>
+				</ol>
+			</fieldset>
+		';
 
 		return $content;
 	}
